/*******************************************************************************
* Copyright (C) 2005, 2006 Novell, Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*
*  - Redistributions in binary form must reproduce the above copyright notice,
*    this list of conditions and the following disclaimer in the documentation
*    and/or other materials provided with the distribution.
*
*  - Neither the name of Novell, Inc. nor the names of its
*    contributors may be used to endorse or promote products derived from this
*    software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL Novell, Inc. OR THE CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
* Author: Norm Paxton (npaxton@novell.com)
******************************************************************************/
#ifndef CMPIUTIL_CMPISIMPLEASSOC_H_GUARD__
#define CMPIUTIL_CMPISIMPLEASSOC_H_GUARD__

#include <cmpidt.h>
#include <cmpift.h>
#include <cmpimacs.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef enum
{
	ASSOCS = 0,
	ASSOCNAMES,
	REFS,
	REFNAMES
} assocType;


typedef struct
{
	const CMPIBroker *broker;
	const CMPIContext *ctx;
	const CMPIResult *results;
	const CMPIObjectPath *origCop;
	const char *role;
	const char **properties;
	assocType type;
}cmpiutilSimpleAssocHandler;

typedef cmpiutilSimpleAssocHandler* cmpiutilSimpleAssocCtx;

void cmpiutilSimpleAssocResults(cmpiutilSimpleAssocCtx ctx,
									 CMPIInstance *inst,
									 CMPIStatus *pStatus);

typedef CMPIStatus (*doReferencesFunc)(cmpiutilSimpleAssocCtx ctx,
								CMPIAssociationMI* self,
								const CMPIBroker *broker,
								const CMPIContext* context,
								const CMPIResult* results,
								const CMPIObjectPath* cop,
								const char *assocClass,
							    const char *resultClass,
								const char *role,
								const char *resultRole,
								const char** properties);

CMPIStatus cmpiutilSimpleAssociators(	doReferencesFunc doRefs,
								CMPIAssociationMI* self,
								const CMPIBroker *broker,
								const CMPIContext* context,
								const CMPIResult* results,
								const CMPIObjectPath* cop,
								const char *assocClass,
								const char *resultClass,
								const char *role,
								const char *resultRole,
								const char** properties);

CMPIStatus cmpiutilSimpleAssociatorNames(	doReferencesFunc doRefs,
								CMPIAssociationMI* self,
								const CMPIBroker *broker,
								const CMPIContext* context,
								const CMPIResult* results,
								const CMPIObjectPath* cop,
								const char *assocClass,
								const char *resultClass,
								const char *role,
								const char *resultRole);

CMPIStatus cmpiutilSimpleReferences(		doReferencesFunc doRefs,
								CMPIAssociationMI* self,
								const CMPIBroker *broker,
								const CMPIContext* context,
								const CMPIResult* results,
								const CMPIObjectPath* cop,
								const char *resultClass,
								const char *role ,
								const char** properties);

CMPIStatus cmpiutilSimpleReferenceNames(	doReferencesFunc doRefs,
								CMPIAssociationMI* self,
								const CMPIBroker *broker,
								const CMPIContext* context,
								const CMPIResult* results,
								const CMPIObjectPath* cop,
								const char* resultClass,
								const char* role);


#ifdef __cplusplus
}
#endif

#endif
